// Code generated by dagger-compiler.  Do not edit.
package feign;


import dagger.internal.Binding;
import dagger.internal.Linker;
import dagger.internal.ModuleAdapter;
import java.util.Map;
import java.util.Set;
import javax.inject.Provider;

/**
 * A manager of modules and provides adapters allowing for proper linking and
 * instance provision of types served by {@code @Provides} methods.
 */
public final class Feign$Defaults$$ModuleAdapter extends ModuleAdapter<Feign.Defaults> {
  private static final String[] INJECTS = { "members/feign.Feign", };
  private static final Class<?>[] STATIC_INJECTIONS = { };
  private static final Class<?>[] INCLUDES = { };

  public Feign$Defaults$$ModuleAdapter() {
    super(INJECTS, STATIC_INJECTIONS, false /*overrides*/, INCLUDES, false /*complete*/, true /*library*/);
  }

  @Override
  protected Feign.Defaults newModule() {
    return new feign.Feign.Defaults();
  }

  /**
   * Used internally obtain dependency information, such as for cyclical
   * graph detection.
   */
  @Override
  public void getBindings(Map<String, Binding<?>> map) {
    map.put("feign.Contract", new ContractProvidesAdapter(module));
    map.put("javax.net.ssl.SSLSocketFactory", new SslSocketFactoryProvidesAdapter(module));
    map.put("feign.Client", new HttpClientProvidesAdapter(module));
    map.put("feign.Retryer", new RetryerProvidesAdapter(module));
    map.put("feign.Wire", new NoOpProvidesAdapter(module));
    map.put("java.util.Map<java.lang.String, feign.Request$Options>", new NoOptionsProvidesAdapter(module));
    map.put("java.util.Map<java.lang.String, feign.codec.BodyEncoder>", new NoBodyEncodersProvidesAdapter(module));
    map.put("java.util.Map<java.lang.String, feign.codec.FormEncoder>", new NoFormEncodersProvidesAdapter(module));
    map.put("java.util.Map<java.lang.String, feign.codec.Decoder>", new NoDecodersProvidesAdapter(module));
    map.put("java.util.Map<java.lang.String, feign.codec.ErrorDecoder>", new NoErrorDecodersProvidesAdapter(module));
  }

  /**
   * A {@code Binder<feign.Contract>} implementation which satisfies
   * Dagger's infrastructure requirements including:
   * 
   * Being a {@code Provider<feign.Contract>} and handling creation and
   * preparation of object instances.
   */
  public static final class ContractProvidesAdapter extends Binding<Contract>
      implements Provider<Contract> {
    private final Feign.Defaults module;

    public ContractProvidesAdapter(Feign.Defaults module) {
      super("feign.Contract", null, NOT_SINGLETON, "feign.Feign.Defaults.contract()");
      this.module = module;
      setLibrary(true);
    }

    /**
     * Returns the fully provisioned instance satisfying the contract for
     * {@code Provider<feign.Contract>}.
     */
    @Override
    public Contract get() {
      return module.contract();
    }
  }

  /**
   * A {@code Binder<javax.net.ssl.SSLSocketFactory>} implementation which satisfies
   * Dagger's infrastructure requirements including:
   * 
   * Being a {@code Provider<javax.net.ssl.SSLSocketFactory>} and handling creation and
   * preparation of object instances.
   */
  public static final class SslSocketFactoryProvidesAdapter extends Binding<javax.net.ssl.SSLSocketFactory>
      implements Provider<javax.net.ssl.SSLSocketFactory> {
    private final Feign.Defaults module;

    public SslSocketFactoryProvidesAdapter(Feign.Defaults module) {
      super("javax.net.ssl.SSLSocketFactory", null, NOT_SINGLETON, "feign.Feign.Defaults.sslSocketFactory()");
      this.module = module;
      setLibrary(true);
    }

    /**
     * Returns the fully provisioned instance satisfying the contract for
     * {@code Provider<javax.net.ssl.SSLSocketFactory>}.
     */
    @Override
    public javax.net.ssl.SSLSocketFactory get() {
      return module.sslSocketFactory();
    }
  }

  /**
   * A {@code Binder<feign.Client>} implementation which satisfies
   * Dagger's infrastructure requirements including:
   * 
   * Owning the dependency links between {@code feign.Client} and its
   * dependencies.
   * 
   * Being a {@code Provider<feign.Client>} and handling creation and
   * preparation of object instances.
   */
  public static final class HttpClientProvidesAdapter extends Binding<Client>
      implements Provider<Client> {
    private final Feign.Defaults module;
    private Binding<Client.Default> client;

    public HttpClientProvidesAdapter(Feign.Defaults module) {
      super("feign.Client", null, NOT_SINGLETON, "feign.Feign.Defaults.httpClient()");
      this.module = module;
      setLibrary(true);
    }

    /**
     * Used internally to link bindings/providers together at run time
     * according to their dependency graph.
     */
    @Override
    @SuppressWarnings("unchecked")
    public void attach(Linker linker) {
      client = (Binding<Client.Default>) linker.requestBinding("feign.Client$Default", Feign.Defaults.class);
    }

    /**
     * Used internally obtain dependency information, such as for cyclical
     * graph detection.
     */
    @Override
    public void getDependencies(Set<Binding<?>> getBindings, Set<Binding<?>> injectMembersBindings) {
      getBindings.add(client);
    }

    /**
     * Returns the fully provisioned instance satisfying the contract for
     * {@code Provider<feign.Client>}.
     */
    @Override
    public Client get() {
      return module.httpClient(client.get());
    }
  }

  /**
   * A {@code Binder<feign.Retryer>} implementation which satisfies
   * Dagger's infrastructure requirements including:
   * 
   * Being a {@code Provider<feign.Retryer>} and handling creation and
   * preparation of object instances.
   */
  public static final class RetryerProvidesAdapter extends Binding<Retryer>
      implements Provider<Retryer> {
    private final Feign.Defaults module;

    public RetryerProvidesAdapter(Feign.Defaults module) {
      super("feign.Retryer", null, NOT_SINGLETON, "feign.Feign.Defaults.retryer()");
      this.module = module;
      setLibrary(true);
    }

    /**
     * Returns the fully provisioned instance satisfying the contract for
     * {@code Provider<feign.Retryer>}.
     */
    @Override
    public Retryer get() {
      return module.retryer();
    }
  }

  /**
   * A {@code Binder<feign.Wire>} implementation which satisfies
   * Dagger's infrastructure requirements including:
   * 
   * Being a {@code Provider<feign.Wire>} and handling creation and
   * preparation of object instances.
   */
  public static final class NoOpProvidesAdapter extends Binding<Wire>
      implements Provider<Wire> {
    private final Feign.Defaults module;

    public NoOpProvidesAdapter(Feign.Defaults module) {
      super("feign.Wire", null, NOT_SINGLETON, "feign.Feign.Defaults.noOp()");
      this.module = module;
      setLibrary(true);
    }

    /**
     * Returns the fully provisioned instance satisfying the contract for
     * {@code Provider<feign.Wire>}.
     */
    @Override
    public Wire get() {
      return module.noOp();
    }
  }

  /**
   * A {@code Binder<java.util.Map<java.lang.String, feign.Request.Options>>} implementation which satisfies
   * Dagger's infrastructure requirements including:
   * 
   * Being a {@code Provider<java.util.Map<java.lang.String, feign.Request.Options>>} and handling creation and
   * preparation of object instances.
   */
  public static final class NoOptionsProvidesAdapter extends Binding<Map<String, Request.Options>>
      implements Provider<Map<String, Request.Options>> {
    private final Feign.Defaults module;

    public NoOptionsProvidesAdapter(Feign.Defaults module) {
      super("java.util.Map<java.lang.String, feign.Request$Options>", null, NOT_SINGLETON, "feign.Feign.Defaults.noOptions()");
      this.module = module;
      setLibrary(true);
    }

    /**
     * Returns the fully provisioned instance satisfying the contract for
     * {@code Provider<java.util.Map<java.lang.String, feign.Request.Options>>}.
     */
    @Override
    public Map<String, Request.Options> get() {
      return module.noOptions();
    }
  }

  /**
   * A {@code Binder<java.util.Map<java.lang.String, feign.codec.BodyEncoder>>} implementation which satisfies
   * Dagger's infrastructure requirements including:
   * 
   * Being a {@code Provider<java.util.Map<java.lang.String, feign.codec.BodyEncoder>>} and handling creation and
   * preparation of object instances.
   */
  public static final class NoBodyEncodersProvidesAdapter extends Binding<Map<String, feign.codec.BodyEncoder>>
      implements Provider<Map<String, feign.codec.BodyEncoder>> {
    private final Feign.Defaults module;

    public NoBodyEncodersProvidesAdapter(Feign.Defaults module) {
      super("java.util.Map<java.lang.String, feign.codec.BodyEncoder>", null, NOT_SINGLETON, "feign.Feign.Defaults.noBodyEncoders()");
      this.module = module;
      setLibrary(true);
    }

    /**
     * Returns the fully provisioned instance satisfying the contract for
     * {@code Provider<java.util.Map<java.lang.String, feign.codec.BodyEncoder>>}.
     */
    @Override
    public Map<String, feign.codec.BodyEncoder> get() {
      return module.noBodyEncoders();
    }
  }

  /**
   * A {@code Binder<java.util.Map<java.lang.String, feign.codec.FormEncoder>>} implementation which satisfies
   * Dagger's infrastructure requirements including:
   * 
   * Being a {@code Provider<java.util.Map<java.lang.String, feign.codec.FormEncoder>>} and handling creation and
   * preparation of object instances.
   */
  public static final class NoFormEncodersProvidesAdapter extends Binding<Map<String, feign.codec.FormEncoder>>
      implements Provider<Map<String, feign.codec.FormEncoder>> {
    private final Feign.Defaults module;

    public NoFormEncodersProvidesAdapter(Feign.Defaults module) {
      super("java.util.Map<java.lang.String, feign.codec.FormEncoder>", null, NOT_SINGLETON, "feign.Feign.Defaults.noFormEncoders()");
      this.module = module;
      setLibrary(true);
    }

    /**
     * Returns the fully provisioned instance satisfying the contract for
     * {@code Provider<java.util.Map<java.lang.String, feign.codec.FormEncoder>>}.
     */
    @Override
    public Map<String, feign.codec.FormEncoder> get() {
      return module.noFormEncoders();
    }
  }

  /**
   * A {@code Binder<java.util.Map<java.lang.String, feign.codec.Decoder>>} implementation which satisfies
   * Dagger's infrastructure requirements including:
   * 
   * Being a {@code Provider<java.util.Map<java.lang.String, feign.codec.Decoder>>} and handling creation and
   * preparation of object instances.
   */
  public static final class NoDecodersProvidesAdapter extends Binding<Map<String, feign.codec.Decoder>>
      implements Provider<Map<String, feign.codec.Decoder>> {
    private final Feign.Defaults module;

    public NoDecodersProvidesAdapter(Feign.Defaults module) {
      super("java.util.Map<java.lang.String, feign.codec.Decoder>", null, NOT_SINGLETON, "feign.Feign.Defaults.noDecoders()");
      this.module = module;
      setLibrary(true);
    }

    /**
     * Returns the fully provisioned instance satisfying the contract for
     * {@code Provider<java.util.Map<java.lang.String, feign.codec.Decoder>>}.
     */
    @Override
    public Map<String, feign.codec.Decoder> get() {
      return module.noDecoders();
    }
  }

  /**
   * A {@code Binder<java.util.Map<java.lang.String, feign.codec.ErrorDecoder>>} implementation which satisfies
   * Dagger's infrastructure requirements including:
   * 
   * Being a {@code Provider<java.util.Map<java.lang.String, feign.codec.ErrorDecoder>>} and handling creation and
   * preparation of object instances.
   */
  public static final class NoErrorDecodersProvidesAdapter extends Binding<Map<String, feign.codec.ErrorDecoder>>
      implements Provider<Map<String, feign.codec.ErrorDecoder>> {
    private final Feign.Defaults module;

    public NoErrorDecodersProvidesAdapter(Feign.Defaults module) {
      super("java.util.Map<java.lang.String, feign.codec.ErrorDecoder>", null, NOT_SINGLETON, "feign.Feign.Defaults.noErrorDecoders()");
      this.module = module;
      setLibrary(true);
    }

    /**
     * Returns the fully provisioned instance satisfying the contract for
     * {@code Provider<java.util.Map<java.lang.String, feign.codec.ErrorDecoder>>}.
     */
    @Override
    public Map<String, feign.codec.ErrorDecoder> get() {
      return module.noErrorDecoders();
    }
  }
}
